﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MYHelper;



namespace Form_legal
{
    public partial class Apply : Form
    {
        public int pageSize = 10;      //每页记录数
        public int recordCount = 0;    //总记录数
        public int pageCount = 0;      //总页数
        public int currentPage = 0;    //当前页
        public DataTable dtSource = new DataTable();

        private string Type;
        public Apply(string type)
        {
            InitializeComponent();
            this.Type = type;
            Bind_levl1();
        }
  
        private void Apply_Load(object sender, EventArgs e)
        {
            //默认第一页
            currentPage = 1;
            LoadPage();
            if (Type == "管理员")
            {
                button5.Visible = true;
            }
            else
            {
                button5.Visible = false;
            }
          
        }
        //未回复信息
        private void button2_Click(object sender, EventArgs e)
        {

        }
        private void LoadPage()
        {
            //数据库操作获得DataTable,获取总页数
            string sql = "select * from L_consult order by ID desc";
            dtSource = SQLHelper.GetTableData(sql);
            recordCount = dtSource.Rows.Count;
            pageCount = (recordCount / pageSize);
            if ((recordCount % pageSize) > 0)
            {
                pageCount++;
            }
            //逻辑判断页数显示
            if (currentPage < 1) currentPage = 1;
            if (currentPage > pageCount) currentPage = pageCount;
            int beginRecord;
            int endRecord;
            DataTable dtTemp;
            dtTemp = dtSource.Clone();
            beginRecord = pageSize * (currentPage - 1);
            if (currentPage == 1) beginRecord = 0;
            endRecord = pageSize * currentPage;
            if (currentPage == pageCount) endRecord = recordCount;
            for (int i = beginRecord; i < endRecord; i++)
            {
                dtTemp.ImportRow(dtSource.Rows[i]);
            }
            dataGridView2.DataSource = dtTemp;
            lblcount.Text = recordCount.ToString();
            lblpagecount.Text = pageCount.ToString();
            lblpage.Text = pageSize.ToString();
            txtindexpage.Text = currentPage.ToString();
        }


        //刷新
        public void Bind()
        {
            string sql = "select * from L_consult order by ID desc";
            DataSet ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                dataGridView2.DataSource = ds.Tables[0];

            }
        }
     
        #region 级联咨询类型
        public void Bind_levl1()
        {
            string sql = "select * from A_type ";
            DataSet   ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].NewRow();
                dr[0] = "0";
                dr[1] = "请选择";
                ds.Tables[0].Rows.InsertAt(dr, 0);
                comboBox1.DataSource = ds.Tables[0];
                comboBox1.DisplayMember = "name";
                comboBox1.ValueMember = "ID";
                this.comboBox1.SelectedValue = "0";
            }
        }
        public void Bind_levl2(string aname)
        {
            string sql = "select * from B_type where aname='"+aname+"'";
            DataSet ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].NewRow();
                dr[0] = "0";
                dr[2] = "请选择";
                ds.Tables[0].Rows.InsertAt(dr, 0);
                comboBox2.DataSource = ds.Tables[0];
                comboBox2.DisplayMember = "bname";
                comboBox2.ValueMember = "ID";
                this.comboBox2.SelectedValue = "0";
            }
        }
        public void Bind_levl3(string bname)
        {
            string sql = "select * from C_type where bname='" + bname + "'";
            DataSet ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                DataRow dr = ds.Tables[0].NewRow();
                dr[0] = "0";
                dr[2] = "请选择";
                ds.Tables[0].Rows.InsertAt(dr, 0);
                comboBox3.DataSource = ds.Tables[0];
                comboBox3.DisplayMember = "cname";
                comboBox3.ValueMember = "ID";
                this.comboBox3.SelectedValue = "0";
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.SelectedValue.ToString() == "0")
            {

                MessageBox.Show("输入不合法，请选择！！");
            }
            else
            {
                string name = comboBox1.Text;
                Bind_levl2(name);
            }
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox2.SelectedValue.ToString() == "0")
            {

                MessageBox.Show("输入不合法，请选择！！");
            }
            else
            {
                string name = comboBox2.Text;
                Bind_levl3(name);
            }
        }
        #endregion

     
        //清除
        public void Clear()
        {
            txtname.Text = "";
            txtaddress.Text = "";
            rtxcontent.Text = "";
            radioButton1.Checked = true;
        }
        //判断是否为空值
        public bool IsNull()
        {
            if (txtname.Text == "" || txtaddress.Text == "" || rtxcontent.Text == "" || comboBox1.Text == "请选择")
            {
                MessageBox.Show("文本输入不完整，请填写所有文本信息！");
                return false;
            }
            else
            {
                return true;
            }
        }
        //添加咨询信息
        private void button1_Click(object sender, EventArgs e)
        {
            if (IsNull() == true)
            {
                string sex;
                if (radioButton1.Checked == true)
                {
                    sex = "男";
                }
                else
                {
                    sex = "女";
                }
                string date = DateTime.Now.ToString("yyyy-MM-dd");
                string type="";
                if (comboBox1.Text!="请选择"&&comboBox2.Text == "请选择")
                {
                    //type = comboBox1.Text;
                    MessageBox.Show("咨询类型填写不完整，请继续填写！");
                }
                if (comboBox1.Text != "请选择" && comboBox2.Text != "请选择" && comboBox3.Text == "请选择")
                {
                    //type = comboBox1.Text+"|" + comboBox2.Text;
                    MessageBox.Show("咨询类型填写不完整，请继续填写！");
                }
                if (comboBox1.Text != "请选择" && comboBox2.Text != "请选择" && comboBox3.Text != "请选择")
                {
                    type = comboBox1.Text + " " + comboBox2.Text + " " + comboBox3.Text;
                }
                if (type != "")
                {
                    string sql = "insert into L_consult(name,sex,address,type,content,reply,mydate,flag) values('" + txtname.Text + "','" + sex + "','" + txtaddress.Text + "','" + type + "','" + rtxcontent.Text + "','','" + date + "','false')";
                    int i = SQLHelper.ExecuteQuery(sql);
                    if (i > 0)
                    {
                        MessageBox.Show("添加成功！");
                        this.LoadPage();
                        //this.Clear();
                    }
                    else
                    {
                        MessageBox.Show("添加失败！");
                    }
                }
            }
        }
        //更新
        private void dataGridView2_DoubleClick(object sender, EventArgs e)
        {
            int index = dataGridView2.CurrentRow.Index;
            int EmpId = Convert.ToInt32(dataGridView2.Rows[index].Cells[0].Value.ToString());
            DetailApply da = new DetailApply(EmpId);
            da.Show();
        }
        //刷新
        private void button4_Click(object sender, EventArgs e)
        {
            LoadPage();
        }
        //删除
        private void button5_Click(object sender, EventArgs e)
        {
            if (dataGridView2.SelectedRows.Count > 0)
            {
                if (dataGridView2.Rows.Count > 0)
                {
                    int index = dataGridView2.CurrentRow.Index;
                    int EmpId = Convert.ToInt32(dataGridView2.Rows[index].Cells[0].Value.ToString());

                    if (MessageBox.Show("删除后将不能恢复！", "提示信息", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK)
                    {
                        string sql = "delete  from L_consult where ID=" + EmpId;
                     
                        int i = SQLHelper.ExecuteQuery(sql);
                        if (i > 0)
                        {
                            MessageBox.Show("删除成功！");
                            this.LoadPage();
                        }
                    }
                }
            }
        }
        //首页
        private void bntfrist_Click(object sender, EventArgs e)
        {
            currentPage = 1;
            LoadPage();
        }
        //上一页
        private void bntpriove_Click(object sender, EventArgs e)
        {
            currentPage--;
            LoadPage();
        }
        //下一页
        private void bntnext_Click(object sender, EventArgs e)
        {
            currentPage++;
            LoadPage();
        }
        //尾页
        private void bntlast_Click(object sender, EventArgs e)
        {
            currentPage = pageCount;
            LoadPage();
        }
        //跳转
        private void bntGO_Click(object sender, EventArgs e)
        {
            if (txtgo.Text == "")
            {
                int pageN = 1;
            }
            else
            {
                int pageN = Convert.ToInt32(txtgo.Text);
                currentPage = pageN;
                LoadPage();
            }
        }
        //导出当前页
        private void bntPF_Click(object sender, EventArgs e)
        {
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView2, true) == true)
            {
                return;
            }
        }
        //导出所有页
        private void bntPL_Click(object sender, EventArgs e)
        {
            Bind();
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView2, true) == true)
            {
                return;
            }
        }
        /// <summary>
        /// 用来记录先前的颜色值
        /// </summary>
        Color colorTmp = Color.White;
        /// <summary>
        /// 记录鼠标形状
        /// </summary>
        Cursor cursorTmp = Cursor.Current;
        //设置数据控件外观
        private void dataGridView2_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {
            
            for (int i = 0; i < dataGridView2.Rows.Count; i++)
            {
                if (i % 2 == 0)
                {
                    dataGridView2.Rows[i].DefaultCellStyle.BackColor = Color.Bisque; ;
                }
                else
                {
                    dataGridView2.Rows[i].DefaultCellStyle.BackColor = Color.White;
                }
            }
        }
        //鼠标划过
        private void dataGridView2_CellMouseEnter(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                colorTmp = dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor;
                dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor = Color.Silver;
                if (e.ColumnIndex == 1)//改变第二列鼠标形状
                {
                    cursorTmp = this.Cursor;
                    this.Cursor = Cursors.Hand;
                }
            }
        }
        //鼠标离开
        private void dataGridView2_CellMouseLeave(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor = colorTmp;
                if (e.ColumnIndex == 1)
                {
                    this.Cursor = cursorTmp;
                }
            }
        }
     


    }
}
