﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MYHelper;

namespace Form_legal
{
    public partial class OneType : Form
    {
        public int pageSize = 10;      //每页记录数
        public int recordCount = 0;    //总记录数
        public int pageCount = 0;      //总页数
        public int currentPage = 0;    //当前页
        public DataTable dtSource = new DataTable();
        public OneType()
        {
            InitializeComponent();
            dataGridView1.AutoResizeColumnHeadersHeight();
        }

        private void OneType_Load(object sender, EventArgs e)
        {
            //默认第一页
            currentPage = 1;
            LoadPage();
        }
        private void LoadPage()
        {
            //数据库操作获得DataTable,获取总页数
            string sql = "select * from A_type order by ID desc";
            dtSource = SQLHelper.GetTableData(sql);
            recordCount = dtSource.Rows.Count;
            pageCount = (recordCount / pageSize);
            if ((recordCount % pageSize) > 0)
            {
                pageCount++;
            }
            //逻辑判断页数显示
            if (currentPage < 1) currentPage = 1;
            if (currentPage > pageCount) currentPage = pageCount;
            int beginRecord;
            int endRecord;
            DataTable dtTemp;
            dtTemp = dtSource.Clone();
            beginRecord = pageSize * (currentPage - 1);
            if (currentPage == 1) beginRecord = 0;
            endRecord = pageSize * currentPage;
            if (currentPage == pageCount) endRecord = recordCount;
            for (int i = beginRecord; i < endRecord; i++)
            {
                dtTemp.ImportRow(dtSource.Rows[i]);
            }
            dataGridView1.DataSource = dtTemp;
            lblcount.Text = recordCount.ToString();
            lblpagecount.Text = pageCount.ToString();
            lblpage.Text = pageSize.ToString();
            txtindexpage.Text = currentPage.ToString();
        }
        //清除
        public void Clear()
        {
            txttype1.Text = "";
        }
        //判断是否为空值
        public bool IsNull()
        {
            if (txttype1.Text == "")
            {
                MessageBox.Show("文本输入不完整，请填写所有文本信息！");
                return false;
            }
            else
            {
                return true;
            }
        }
        //刷新
        private void button3_Click(object sender, EventArgs e)
        {
            //默认第一页
            currentPage = 1;
            LoadPage();
        }
        //添加
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsNull() == true)
                {
                    string sql = "insert into A_type(name) values('" + txttype1.Text + "')";
                    int i = SQLHelper.ExecuteQuery(sql);
                    ; if (i > 0)
                    {
                        MessageBox.Show("添加成功！");
                        this.LoadPage();
                        this.Clear();
                    }
                    else
                    {
                        MessageBox.Show("添加失败！");
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + ex.StackTrace);
            }
        }
        //级联修改
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsNull() == true)
                {
                     int index = dataGridView1.CurrentRow.Index;
                     int EmpId = Convert.ToInt32(dataGridView1.Rows[index].Cells[0].Value.ToString());
                    //修改a表
                    string asql = "update  A_type set name='" + txttype1.Text.ToString() + "' where ID=" + EmpId;
                  
                    string sqlaname = "select name from A_type  where ID=" + EmpId;//条件关联子表
                    DataTable dt = MYHelper.SQLHelper.GetTableData(sqlaname);
                    string aname = dt.Rows[0]["name"].ToString();
                    int a = SQLHelper.ExecuteQuery(asql);
                    DataTable dta = MYHelper.SQLHelper.GetTableData(sqlaname);
                    string aaname = dta.Rows[0]["name"].ToString();
                   //修改b表
                    string bsql = "update  B_type set aname='" + aaname + "' where aname='" + aname + "'";
                  
                    int b = SQLHelper.ExecuteQuery(bsql);
                    if (a > 0&&b>0)
                    {
                        MessageBox.Show("添加成功！");
                        this.LoadPage();
                        this.Clear();
                    }
                    else
                    {
                        MessageBox.Show("添加失败！");
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + ex.StackTrace);
            }
        }
        //级联删除
        private void button2_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                if (dataGridView1.Rows.Count > 0)
                {
                    int index = dataGridView1.CurrentRow.Index;
                    int EmpId = Convert.ToInt32(dataGridView1.Rows[index].Cells[0].Value.ToString());

                    if (MessageBox.Show("删除后将不能恢复！", "提示信息", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK)
                    {
                        //删除A表
                        string asql = "delete  from A_type where ID=" + EmpId;//删除父级别类型
                        //删除B表
                        string sqlaname = "select name from A_type  where ID="+EmpId;//条件关联删除子表
                        DataTable dt = MYHelper.SQLHelper.GetTableData(sqlaname);
                        string aname = dt.Rows[0]["name"].ToString();
                        string sqlbname = "select bname from B_type  where aname='" + aname + "'";//条件关联删除子表
                        DataTable dtb = MYHelper.SQLHelper.GetTableData(sqlbname);
                        int c=0;
                        for (int i = 0; i < dtb.Rows.Count; i++)
                        {
                             string bname = dtb.Rows[i][0].ToString();
                             string csql = "delete  from C_type where bname='" + bname + "'";//删除父级别类型
                             c = SQLHelper.ExecuteQuery(csql);
                        }
                        string bsql = "delete  from B_type where aname='" + aname+"'";//删除父级别类型
                        //删除C表
                      
                        int b = SQLHelper.ExecuteQuery(bsql);
                        int a = SQLHelper.ExecuteQuery(asql);
                        if (a > 0&&b>0&&c>0)
                        {
                            MessageBox.Show("删除成功！");
                            this.LoadPage();
                        }
                    }
                }
            }
        }

        private void dataGridView1_DoubleClick(object sender, EventArgs e)
        {
            int index = dataGridView1.CurrentRow.Index;
            int EmpId = Convert.ToInt32(dataGridView1.Rows[index].Cells[0].Value.ToString());
            string sql = "select * from A_type where ID=" + EmpId;
            DataTable dt = MYHelper.SQLHelper.GetTableData(sql);
            if (dt.Rows.Count > 0)
            {
                txttype1.Text = dt.Rows[0]["name"].ToString();
            }
        }

        private void bntfrist_Click(object sender, EventArgs e)
        {
            currentPage = 1;
            LoadPage();
        }

        private void bntpriove_Click(object sender, EventArgs e)
        {
            currentPage--;
            LoadPage();
        }

        private void bntnext_Click(object sender, EventArgs e)
        {
            currentPage++;
            LoadPage();
        }

        private void bntlast_Click(object sender, EventArgs e)
        {
            currentPage = pageCount;
            LoadPage();
        }
        private void bntGO_Click_1(object sender, EventArgs e)
        {
            if (txtgo.Text == "")
            {
                int pageN = 1;
            }
            else
            {
                int pageN = Convert.ToInt32(txtgo.Text);
                currentPage = pageN;
                LoadPage();
            }
        }

        /// 用来记录先前的颜色值
        /// </summary>
        Color colorTmp = Color.White;
        /// <summary>
        /// 记录鼠标形状
        /// </summary>
        Cursor cursorTmp = Cursor.Current;


        private void dataGridView1_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                if (i % 2 == 0)
                {
                    dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.Bisque; ;
                }
                else
                {
                    dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.White;
                }
            }
        }

        private void dataGridView1_CellMouseEnter(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                colorTmp = dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor;
                dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor = Color.Silver;
                if (e.ColumnIndex == 1)//改变第二列鼠标形状
                {
                    cursorTmp = this.Cursor;
                    this.Cursor = Cursors.Hand;
                }
            }
        }

        private void dataGridView1_CellMouseLeave(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor = colorTmp;
                if (e.ColumnIndex == 1)
                {
                    this.Cursor = cursorTmp;
                }
            }
        }

      
    }
}
