﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using MYHelper;
namespace Form_legal
{
    public partial class UserManage : Form
    {
        public int pageSize = 10;      //每页记录数
        public int recordCount = 0;    //总记录数
        public int pageCount = 0;      //总页数
        public int currentPage = 0;    //当前页
        public DataTable dtSource = new DataTable();
        public UserManage()
        {
            InitializeComponent();
            dataGridView1.AutoResizeColumnHeadersHeight();
        }
        private void UserManage_Load(object sender, EventArgs e)
        {
            //默认第一页
            currentPage = 1;
            LoadPage();
        }
        private void LoadPage()
        {
            //数据库操作获得DataTable,获取总页数
            string sql = "select * from L_user order by ID desc";
            dtSource = SQLHelper.GetTableData(sql);
            recordCount = dtSource.Rows.Count;
            pageCount = (recordCount / pageSize);
            if ((recordCount % pageSize) > 0)
            {
                pageCount++;
            }
            //逻辑判断页数显示
            if (currentPage < 1) currentPage = 1;
            if (currentPage > pageCount) currentPage = pageCount;
            int beginRecord;
            int endRecord;
            DataTable dtTemp;
            dtTemp = dtSource.Clone();
            beginRecord = pageSize * (currentPage - 1);
            if (currentPage == 1) beginRecord = 0;
            endRecord = pageSize * currentPage;
            if (currentPage == pageCount) endRecord = recordCount;
            for (int i = beginRecord; i < endRecord; i++)
            {
                dtTemp.ImportRow(dtSource.Rows[i]);
            }
            dataGridView1.DataSource = dtTemp;
            lblcount.Text = recordCount.ToString();
            lblpagecount.Text = pageCount.ToString();
            lblpage.Text = pageSize.ToString();
            txtindexpage.Text = currentPage.ToString();
        }
        //刷新
        public void Bind()
        {
            string sql = "select * from L_user";
            DataSet ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                dataGridView1.DataSource = ds.Tables[0];
            }
        }
        //清除
        public void Clear()
        {
            txtuser.Text = "";
            txtpass.Text = "";
            txtpass2.Text = "";
            drptype.Text = "";
        }
        //判断是否为空值
        public bool IsNull()
        {
            if (txtuser.Text == "" || txtpass.Text == "" || txtpass2.Text == "" || drptype.Text == "=请选择=")
            {
                MessageBox.Show("文本输入不完整，请填写所有文本信息！");
                return false;
            }
            else if (txtpass.Text != txtpass2.Text)
            {
                MessageBox.Show("两次密码输入不一致！");
                return false;
            }
            else
            {
                return true;
            }
        }
    
        private void button3_Click(object sender, EventArgs e)
        {
            //if (txtsname.Text != "" || drpstype.Text != "=请选择=")
            //{

            //    string sql="select * from L_user where name='"+txtsname.Text+"' or type='"+drpstype.SelectedText+"'";
            //    DataSet ds = SQLHelper.GetSetData(sql);
            //    if (ds.Tables[0].Rows.Count > 0)
            //    {
            //        dataGridView1.DataSource = ds.Tables[0];
            //        this.Clear();
            //    }
            //}
            //else
            //{
            //    MessageBox.Show("查询条件不能为空！");
            //}
        }

 
        //添加信息
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                if (IsNull() == true)
                {
                    string sql = "insert into L_user(name,pwd,type,IP) values('" + txtuser.Text + "','" + txtpass.Text + "','" + drptype.Text + "','')";
                    int i = SQLHelper.ExecuteQuery(sql);
                    ; if (i > 0)
                    {
                        MessageBox.Show("添加成功！");
                        this.LoadPage();
                        this.Clear();
                    }
                    else
                    {
                        MessageBox.Show("添加失败！");
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + ex.StackTrace);
            }
        }
        //删除
        private void button2_Click_1(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedRows.Count > 0)
            {
                if (dataGridView1.Rows.Count > 0)
                {
                    int index = dataGridView1.CurrentRow.Index;
                    int EmpId = Convert.ToInt32(dataGridView1.Rows[index].Cells[0].Value.ToString());

                    if (MessageBox.Show("删除后将不能恢复！", "提示信息", MessageBoxButtons.OKCancel, MessageBoxIcon.Warning) == DialogResult.OK)
                    {
                        string sql = "delete  from L_user where ID=" + EmpId;
                        int i = SQLHelper.ExecuteQuery(sql);
                        if (i > 0)
                        {
                            MessageBox.Show("删除成功！");
                            this.LoadPage();
                        }
                    }
                }
            }
        }
     
        //详细信息
        private void dataGridView1_DoubleClick(object sender, EventArgs e)
        {
            int index = dataGridView1.CurrentRow.Index;
            int EmpId = Convert.ToInt32(dataGridView1.Rows[index].Cells[0].Value.ToString());
            DetailUser du = new DetailUser(EmpId);
            du.Show();

        }
        //刷新
        private void button3_Click_1(object sender, EventArgs e)
        {
            this.LoadPage();
        }

        private void bntfrist_Click(object sender, EventArgs e)
        {
            currentPage = 1;
            LoadPage();
        }

        private void bntpriove_Click(object sender, EventArgs e)
        {
            currentPage--;
            LoadPage();
        }

        private void bntnext_Click(object sender, EventArgs e)
        {
            currentPage++;
            LoadPage();
        }

        private void bntlast_Click(object sender, EventArgs e)
        {
            currentPage = pageCount;
            LoadPage();
        }

        private void bntGO_Click(object sender, EventArgs e)
        {

            if (txtgo.Text == "")
            {
                int pageN = 1;
            }
            else
            {
                int pageN = Convert.ToInt32(txtgo.Text);
                currentPage = pageN;
                LoadPage();
            }
        }

        private void bntPF_Click(object sender, EventArgs e)
        {
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView1, true) == true)
            {
                return;
            }
        }

        private void bntPL_Click(object sender, EventArgs e)
        {
            Bind();
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView1, true) == true)
            {
                return;
            }
        }
        /// 用来记录先前的颜色值
        /// </summary>
        Color colorTmp = Color.White;
        /// <summary>
        /// 记录鼠标形状
        /// </summary>
        Cursor cursorTmp = Cursor.Current;
       

        private void dataGridView1_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {
            for (int i = 0; i < dataGridView1.Rows.Count; i++)
            {
                if (i % 2 == 0)
                {
                    dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.Bisque; ;
                }
                else
                {
                    dataGridView1.Rows[i].DefaultCellStyle.BackColor = Color.White;
                }
            }
        }

        private void dataGridView1_CellMouseEnter(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                colorTmp = dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor;
                dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor = Color.Silver;
                if (e.ColumnIndex == 1)//改变第二列鼠标形状
                {
                    cursorTmp = this.Cursor;
                    this.Cursor = Cursors.Hand;
                }
            }
        }

        private void dataGridView1_CellMouseLeave(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                dataGridView1.Rows[e.RowIndex].DefaultCellStyle.BackColor = colorTmp;
                if (e.ColumnIndex == 1)
                {
                    this.Cursor = cursorTmp;
                }
            }
        }
    }
}
