﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MYHelper;

namespace Form_legal
{
    public partial class tabapply : Form
    {
        public int pageSize = 10;      //每页记录数
        public int recordCount = 0;    //总记录数
        public int pageCount = 0;      //总页数
        public int currentPage = 0;    //当前页
        public DataTable dtSource = new DataTable();
        public tabapply()
        {
            InitializeComponent();
        }

        private void tabapply_Load(object sender, EventArgs e)
        {

            //默认第一页
            currentPage = 1;
            LoadPage();
        }
        private void LoadPage()
        {
            //数据库操作获得DataTable,获取总页数
            string sql = "select * from L_consult order by ID desc";
            dtSource = SQLHelper.GetTableData(sql);
            recordCount = dtSource.Rows.Count;
            pageCount = (recordCount / pageSize);
            if ((recordCount % pageSize) > 0)
            {
                pageCount++;
            }
            //逻辑判断页数显示
            if (currentPage < 1) currentPage = 1;
            if (currentPage > pageCount) currentPage = pageCount;
            int beginRecord;
            int endRecord;
            DataTable dtTemp;
            dtTemp = dtSource.Clone();
            beginRecord = pageSize * (currentPage - 1);
            if (currentPage == 1) beginRecord = 0;
            endRecord = pageSize * currentPage;
            if (currentPage == pageCount) endRecord = recordCount;
            for (int i = beginRecord; i < endRecord; i++)
            {
                dtTemp.ImportRow(dtSource.Rows[i]);
            }
            dataGridView2.DataSource = dtTemp;
            lblcount.Text = recordCount.ToString();
            lblpagecount.Text = pageCount.ToString();
            lblpage.Text = pageSize.ToString();
            txtindexpage.Text = currentPage.ToString();
        }

        //首页
        private void bntfrist_Click(object sender, EventArgs e)
        {
            currentPage = 1;
            LoadPage();
        }
        //上一页
        private void bntpriove_Click(object sender, EventArgs e)
        {
            currentPage--;
            LoadPage();
        }
        //下一页
        private void bntnext_Click(object sender, EventArgs e)
        {
            currentPage++;
            LoadPage();
        }
        //尾页
        private void bntlast_Click(object sender, EventArgs e)
        {
            currentPage = pageCount;
            LoadPage();
        }
        //跳转
        private void bntGO_Click(object sender, EventArgs e)
        {
            if (txtgo.Text == "")
            {
                int pageN = 1;
            }
            else
            {
                int pageN = Convert.ToInt32(txtgo.Text);
                currentPage = pageN;
                LoadPage();
            }
        }
    
        //刷新
        public void Bind()
        {
            string sql = "select * from L_consult order by ID desc";
            DataSet ds = SQLHelper.GetSetData(sql);
            if (ds.Tables[0].Rows.Count > 0)
            {
                dataGridView2.DataSource = ds.Tables[0];

            }
        }
      
        /// <summary>
        /// 用来记录先前的颜色值
        /// </summary>
        Color colorTmp = Color.White;
        /// <summary>
        /// 记录鼠标形状
        /// </summary>
        Cursor cursorTmp = Cursor.Current;
        private void dataGridView2_DataBindingComplete(object sender, DataGridViewBindingCompleteEventArgs e)
        {

            for (int i = 0; i < dataGridView2.Rows.Count; i++)
            {
                if (i % 2 == 0)
                {
                    dataGridView2.Rows[i].DefaultCellStyle.BackColor = Color.Bisque; ;
                }
                else
                {
                    dataGridView2.Rows[i].DefaultCellStyle.BackColor = Color.White;
                }
            }
        }

        private void dataGridView2_CellMouseEnter(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                colorTmp = dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor;
                dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor = Color.Silver;
                if (e.ColumnIndex == 1)//改变第二列鼠标形状
                {
                    cursorTmp = this.Cursor;
                    this.Cursor = Cursors.Hand;
                }
            }
        }

        private void dataGridView2_CellMouseLeave(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                dataGridView2.Rows[e.RowIndex].DefaultCellStyle.BackColor = colorTmp;
                if (e.ColumnIndex == 1)
                {
                    this.Cursor = cursorTmp;
                }
            }
        }

        private void bntPF_Click_1(object sender, EventArgs e)
        {
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView2, true) == true)
            {
                return;
            }
        }

        private void bntPL_Click(object sender, EventArgs e)
        {
            Bind();
            ExcelControl ec = new ExcelControl();
            if (ec.DataGridviewShowToExcel(dataGridView2, true) == true)
            {
                return;
            }
        }
        public void SelectConsult(string name, string address,string falg)
        {
            try
            {
                string sql="";
                if (name == "" && address == "")
                {
                    sql = "select * from L_consult where flag='" + falg + "' order by ID desc";
                }
                else if (name == "")
                {
                    sql = "select * from L_consult where  address like '" + "%" + address + "%" + "'  and  flag='" + falg + "' order by ID desc";
                }
                else if (address == "")
                {
                    sql = "select * from L_consult where name like '" + "%" + name + "%" + "' and flag='" + falg + "' order by ID desc";
                }
                //数据库操作获得DataTable,获取总页数
             
                dtSource = SQLHelper.GetTableData(sql);
                if (dtSource.Rows.Count > 0)
                {
                    recordCount = dtSource.Rows.Count;
                    pageCount = (recordCount / pageSize);
                    if ((recordCount % pageSize) > 0)
                    {
                        pageCount++;
                    }
                    //逻辑判断页数显示
                    if (currentPage < 1) currentPage = 1;
                    if (currentPage > pageCount) currentPage = pageCount;
                    int beginRecord;
                    int endRecord;
                    DataTable dtTemp;
                    dtTemp = dtSource.Clone();
                    beginRecord = pageSize * (currentPage - 1);
                    if (currentPage == 1) beginRecord = 0;
                    endRecord = pageSize * currentPage;
                    if (currentPage == pageCount) endRecord = recordCount;
                    for (int i = beginRecord; i < endRecord; i++)
                    {
                        dtTemp.ImportRow(dtSource.Rows[i]);
                    }
                    dataGridView2.DataSource = dtTemp;
                    lblcount.Text = recordCount.ToString();
                    lblpagecount.Text = pageCount.ToString();
                    lblpage.Text = pageSize.ToString();
                    txtindexpage.Text = currentPage.ToString();
                }
                else {
                    if (falg=="False")
                    {
                        MessageBox.Show("你很勤快，都已经回复过了！！");
                       
                    }
                    else if (falg == "True")
                    {
                        MessageBox.Show("抱歉，你目前都没有回复！！");
                      
                    }
                }
            }
            catch (Exception ex)
            {
                return;
            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            string name = txtuser.Text;
            string address = txtaddress.Text;
            bool flag;
            if (drpflag.Text == "未审核")
            {
                flag = false;
            }
            else
            {
                flag = true;
            }
            SelectConsult(name, address, flag.ToString());
        }

        private void dataGridView2_DoubleClick(object sender, EventArgs e)
        {
            int index = dataGridView2.CurrentRow.Index;
            int EmpId = Convert.ToInt32(dataGridView2.Rows[index].Cells[0].Value.ToString());
            DetailApply da = new DetailApply(EmpId);
            da.Show();
        }

    }
}
